<?php
class pluginSoundCloudEmbed extends Plugin {
    public function init()
    {
        $this->dbFields = array();
    }
    public function siteHead()
    {
        echo '<style>
                .soundcloud-embed {
                    position: relative;
                    padding-bottom: 56.25%;
                    height: 0;
                    overflow: hidden;
                    margin-bottom: 10px;
                }
                .soundcloud-embed iframe {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    frameborder: 0;
                    allow: "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture";
                    allowfullscreen;
                }
              </style>';
    }
    public function siteBodyEnd() {
        echo <<<HTML
    <script>
    document.addEventListener("DOMContentLoaded", function() {
        function createSoundCloudEmbed(soundcloudId) {
            var div = document.createElement('div');
            div.className = 'soundcloud-embed';
            div.innerHTML = '<iframe src="https://w.soundcloud.com/player/?url=https%3A//api.soundcloud.com/tracks/' + soundcloudId + '&color=%23ff5500&auto_play=false&hide_related=false&show_comments=true&show_user=true&show_reposts=false&show_teaser=true&visual=true" allowfullscreen></iframe>';
            return div;
        }
        var paragraphs = document.querySelectorAll('p');
        paragraphs.forEach(function(p) {
            var html = p.innerHTML;
            var regex = /\\s*\\[soundcloud=(.*?)\\]\\s*/g;
            var match, hasReplacement = false;
            while (match = regex.exec(html)) {
                var soundcloudEmbed = createSoundCloudEmbed(match[1]);
                if (!hasReplacement) {
                    p.parentNode.replaceChild(soundcloudEmbed, p);
                    hasReplacement = true;
                } else {
                    p.parentNode.insertBefore(soundcloudEmbed, p.nextSibling);
                }
            }
        });
    });
    </script>
    HTML;
    }
}